## kid3 2.0.1

=== CMakeLists.txt ===
# Build Kid3 using CMake
#
# Linux:
# cmake -D CMAKE_BUILD_TYPE=Release -D WITH_KDE=OFF -D CMAKE_INSTALL_PREFIX=/usr ../kid3
# make
# make install/strip DESTDIR=$(pwd)/inst # or
# cpack
#
# Windows:
# set INCLUDE=%MSYSDIR%\local\include
# set LIB=%MSYSDIR%\local\lib
# cmake -G "MinGW Makefiles" -D CMAKE_BUILD_TYPE=Release -D CMAKE_INSTALL_PREFIX= -D WITH_TUNEPIMP=OFF ..\kid3
# mingw32-make
# cpack
#
# Mac OS X:
# cmake -G "Unix Makefiles" -D CMAKE_BUILD_TYPE=Release -D CMAKE_INSTALL_PREFIX= -D WITH_TUNEPIMP=OFF ../kid3
# make
# cpack

project(kid3)

set(WITH_TAGLIB ON CACHE BOOL "build with TagLib")
set(WITH_MP4V2 OFF CACHE BOOL "build with mp4v2")
set(WITH_ID3LIB ON CACHE BOOL "build with id3lib")
set(WITH_VORBIS ON CACHE BOOL "build with Ogg/Vorbis")
set(WITH_FLAC ON CACHE BOOL "build with FLAC")
set(WITH_TUNEPIMP ON CACHE BOOL "build with TunePimp")
set(WITH_DBUS ON CACHE BOOL "build with QtDBus")
set(WITH_PHONON ON CACHE BOOL "build with Phonon")
set(WITH_GCC_PCH OFF CACHE BOOL "enable precompiled headers")
if (APPLE OR WIN32)
  set(WITH_KDE OFF CACHE BOOL "build with KDE libraries")
else (APPLE OR WIN32)
  set(WITH_KDE ON CACHE BOOL "build with KDE libraries")
endif (APPLE OR WIN32)

# Version information
set(CPACK_PACKAGE_VERSION_MAJOR 2)
set(CPACK_PACKAGE_VERSION_MINOR 0)
set(CPACK_PACKAGE_VERSION_PATCH 1)
set(RELEASE_YEAR 2011)

if (WITH_GCC_PCH)
include(GccPchMacros.cmake)
endif (WITH_GCC_PCH)

if (WITH_KDE)

find_package(KDE4 REQUIRED)
if (WITH_PHONON)
  find_package(Phonon)
endif (WITH_PHONON)
include (KDE4Defaults)

# Set variables used to install shared libraries
set(WITH_BINDIR ${BIN_INSTALL_DIR})
set(WITH_LIBDIR ${LIB_INSTALL_DIR})

if (BUILD_SHARED_LIBS AND __KDE_HAVE_GCC_VISIBILITY)
  message(WARNING "Use -D__KDE_HAVE_GCC_VISIBILITY=OFF to build KDE shared libraries")
endif (BUILD_SHARED_LIBS AND __KDE_HAVE_GCC_VISIBILITY)

else (WITH_KDE)

find_package(Threads)

# Platform specific default installation paths
if (APPLE)
  set(WITH_DATAROOTDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_DOCDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_TRANSLATIONSDIR_DEFAULT "kid3.app/Contents/Resources")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT ".")
elseif (WIN32)
  set(WITH_DATAROOTDIR_DEFAULT ".")
  set(WITH_DOCDIR_DEFAULT ".")
  set(WITH_TRANSLATIONSDIR_DEFAULT ".")
  set(WITH_BINDIR_DEFAULT ".")
  set(WITH_LIBDIR_DEFAULT ".")
else (APPLE)
  set(WITH_DATAROOTDIR_DEFAULT "share")
  set(WITH_DOCDIR_DEFAULT "share/doc/kid3-qt")
  set(WITH_TRANSLATIONSDIR_DEFAULT "share/kid3-qt/translations")
  set(WITH_BINDIR_DEFAULT "bin")
  set(WITH_LIBDIR_DEFAULT "lib")
endif (APPLE)

set(WITH_DATAROOTDIR ${WITH_DATAROOTDIR_DEFAULT} CACHE STRING
    "data root directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_DOCDIR ${WITH_DOCDIR_DEFAULT} CACHE STRING
    "documentation directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_TRANSLATIONSDIR ${WITH_TRANSLATIONSDIR_DEFAULT} CACHE STRING
    "translations directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_BINDIR ${WITH_BINDIR_DEFAULT} CACHE STRING
    "binary directory relative to CMAKE_INSTALL_PREFIX")
set(WITH_LIBDIR ${WITH_LIBDIR_DEFAULT} CACHE STRING
    "library directory relative to CMAKE_INSTALL_PREFIX")
if (CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX_SLASH "${CMAKE_INSTALL_PREFIX}/")
else (CMAKE_INSTALL_PREFIX)
  set(CMAKE_INSTALL_PREFIX_SLASH "")
endif (CMAKE_INSTALL_PREFIX)

set(CFG_DATAROOTDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_DATAROOTDIR})
set(CFG_DOCDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_DOCDIR})
set(CFG_TRANSLATIONSDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_TRANSLATIONSDIR})

cmake_minimum_required(VERSION 2.8)
set(_QT4_COMPONENTS QtCore QtGui QtNetwork QtXml)
if (WIN32)
  set(QT_USE_QTMAIN TRUE)
endif (WIN32)
set(QT_USE_QTDBUS ${WITH_DBUS})
find_package(Qt4 COMPONENTS ${_QT4_COMPONENTS} REQUIRED)
include (${QT_USE_FILE})
include (CheckCXXSourceCompiles)
find_package(Perl REQUIRED)

### Check for xsltproc
find_program(XSLTPROC xsltproc DOC "xsltproc transforms XML via XSLT"
  PATHS $ENV{XSLTPROCDIR})
if (NOT XSLTPROC)
  message(FATAL_ERROR "Could not find xsltproc")
endif (NOT XSLTPROC)

### Check for HTML docbook.xsl
file(GLOB _versionedStyleSheetDir /usr/share/xml/docbook/xsl-stylesheets-*)
find_path(DOCBOOK_XSL_DIR html/docbook.xsl
  PATHS ${WITH_DOCBOOKDIR}
        /usr/share/xml/docbook/stylesheet/nwalsh
        /usr/share/xml/docbook/stylesheet/nwalsh/current
        /usr/share/xml/docbook/stylesheet/docbook-xsl
        /usr/share/xml/docbook/stylesheet/docbook-xsl-ns
        /usr/share/sgml/docbook/xsl-stylesheets
        /usr/share/apps/ksgmltools2/docbook/xsl
       ${_versionedStyleSheetDir}
       $ENV{DOCBOOKDIR}
       $ENV{HOME}/docbook-xsl-1.72.0
  NO_DEFAULT_PATH)
if (NOT DOCBOOK_XSL_DIR)
  message(FATAL_ERROR "Could not find HTML docbook.xsl")
endif (NOT DOCBOOK_XSL_DIR)

endif (WITH_KDE)

include (CheckLibraryExists)

if (WITH_KDE)
  set(CONFIG_USE_KDE 1)
  set(BASIC_LIBRARIES ${KDE4_KDEUI_LIBS} ${KDE4_KIO_LIBS})
  if (WITH_PHONON)
    set(BASIC_LIBRARIES ${BASIC_LIBRARIES} ${PHONON_LIBS})
  endif (WITH_PHONON)
else (WITH_KDE)
  set(BASIC_LIBRARIES ${QT_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
  if (APPLE)
    set(BASIC_LIBRARIES ${BASIC_LIBRARIES} "-framework CoreServices")
  endif (APPLE)
endif (WITH_KDE)

if (WIN32)
link_directories($ENV{LIB})
endif (WIN32)

### Check for taglib
set(TAGLIB_LIBRARIES)
set(TAGLIB_CFLAGS)
if(WITH_TAGLIB)
  if (WIN32)
  find_library(TAGLIB_LIBRARIES NAMES tag)
  find_path(TAGLIB_INCLUDE_DIR taglib.h PATHS $ENV{INCLUDE}/taglib)
  if (TAGLIB_LIBRARIES AND TAGLIB_INCLUDE_DIR)
    set(TAGLIB_CFLAGS -I${TAGLIB_INCLUDE_DIR} -DTAGLIB_STATIC)
    set(HAVE_TAGLIB 1)
  endif (TAGLIB_LIBRARIES AND TAGLIB_INCLUDE_DIR)
  else (WIN32)
  find_program(TAGLIBCONFIG_EXECUTABLE NAMES taglib-config PATHS /usr/bin /usr/local/bin ${BIN_INSTALL_DIR})
  if(TAGLIBCONFIG_EXECUTABLE)
    exec_program(${TAGLIBCONFIG_EXECUTABLE} ARGS --libs RETURN_VALUE _return_VALUE OUTPUT_VARIABLE TAGLIB_LIBRARIES)
    exec_program(${TAGLIBCONFIG_EXECUTABLE} ARGS --cflags RETURN_VALUE _return_VALUE OUTPUT_VARIABLE TAGLIB_CFLAGS)
    exec_program(${TAGLIBCONFIG_EXECUTABLE} ARGS --version RETURN_VALUE _return_VALUE OUTPUT_VARIABLE TAGLIB_VERSION)
    if(TAGLIB_LIBRARIES AND TAGLIB_CFLAGS AND TAGLIB_VERSION)
      if(NOT ${TAGLIB_VERSION} VERSION_LESS 1.4)
        set(HAVE_TAGLIB 1)
        message(STATUS "TagLib found: ${TAGLIB_LIBRARIES}")
      endif(NOT ${TAGLIB_VERSION} VERSION_LESS 1.4)
    endif(TAGLIB_LIBRARIES AND TAGLIB_CFLAGS AND TAGLIB_VERSION)
  endif(TAGLIBCONFIG_EXECUTABLE)
  if (NOT HAVE_TAGLIB)
    message(FATAL_ERROR "Could not find Taglib")
  endif (NOT HAVE_TAGLIB)
  endif (WIN32)
endif(WITH_TAGLIB)
if (TAGLIB_LIBRARIES AND TAGLIB_CFLAGS)
  set(_CMAKE_REQUIRED_LIBRARIES_TMP ${CMAKE_REQUIRED_LIBRARIES})
  set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${TAGLIB_LIBRARIES})
  set(_CMAKE_REQUIRED_DEFINITIONS_TMP ${CMAKE_REQUIRED_DEFINITIONS})
  set(CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS} ${TAGLIB_CFLAGS})
  CHECK_CXX_SOURCE_COMPILES("#include <mp4file.h>\nint main() {\n  TagLib::MP4::Item item;\n  item.toUInt();\n  return 0;\n}\n" HAVE_TAGLIB_MP4_UINTTYPES)
  set(CMAKE_REQUIRED_LIBRARIES ${_CMAKE_REQUIRED_LIBRARIES_TMP})
  set(CMAKE_REQUIRED_DEFINITIONS ${_CMAKE_REQUIRED_DEFINITIONS_TMP})
endif (TAGLIB_LIBRARIES AND TAGLIB_CFLAGS)

### Check for mp4v2
set(MP4V2_LIBRARIES)
if(WITH_MP4V2)
  find_path(MP4V2_INCLUDE_DIR mp4.h
   /usr/include/
   /usr/local/include/
  )

  find_path(MP4V2_MP4V2_INCLUDE_DIR mp4v2/mp4v2.h
   /usr/include/
   /usr/local/include/
  )

  find_library(MP4V2_LIBRARIES NAMES mp4v2
   PATHS
   /usr/lib
   /usr/local/lib
  )

  if (MP4V2_MP4V2_INCLUDE_DIR)
    set(MP4V2_INCLUDE_DIR ${MP4V2_MP4V2_INCLUDE_DIR})
    set(HAVE_MP4V2_MP4V2_H 1)
  endif (MP4V2_MP4V2_INCLUDE_DIR)

  if (MP4V2_INCLUDE_DIR AND MP4V2_LIBRARIES)
    message(STATUS "mp4v2 found: ${MP4V2_LIBRARIES}")
    set(HAVE_MP4V2 1)
    set(MP4V2_FOUND TRUE)

    set(_CMAKE_REQUIRED_LIBRARIES_TMP ${CMAKE_REQUIRED_LIBRARIES})
    set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${MP4V2_LIBRARIES})
    set(_CMAKE_REQUIRED_INCLUDES_TMP ${CMAKE_REQUIRED_INCLUDES})
    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${MP4V2_INCLUDE_DIR})
    if (MP4V2_MP4V2_INCLUDE_DIR)
      CHECK_CXX_SOURCE_COMPILES("#include <mp4v2/mp4v2.h>\nint main() {\n  MP4FileHandle hFile;\n  uint32_t index;\n  char* ppName;\n  uint8_t* ppValue;\n  uint32_t pValueSize;\n  MP4GetMetadataByIndex(hFile, index, &ppName, &ppValue, &pValueSize);\n  return 0;\n}\n" HAVE_MP4V2_MP4GETMETADATABYINDEX_CHARPP_ARG)
    else (MP4V2_MP4V2_INCLUDE_DIR)
      CHECK_CXX_SOURCE_COMPILES("#include <mp4.h>\nint main() {\n  MP4FileHandle hFile;\n  u_int32_t index;\n  char* ppName;\n  u_int8_t* ppValue;\n  u_int32_t pValueSize;\n  MP4GetMetadataByIndex(hFile, index, &ppName, &ppValue, &pValueSize);\n  return 0;\n}\n" HAVE_MP4V2_MP4GETMETADATABYINDEX_CHARPP_ARG)
    endif (MP4V2_MP4V2_INCLUDE_DIR)
    set(CMAKE_REQUIRED_LIBRARIES ${_CMAKE_REQUIRED_LIBRARIES_TMP})
    set(CMAKE_REQUIRED_INCLUDES ${_CMAKE_REQUIRED_INCLUDES_TMP})

  else (MP4V2_INCLUDE_DIR AND MP4V2_LIBRARIES)
    message(STATUS "Could not find mp4v2")
  endif (MP4V2_INCLUDE_DIR AND MP4V2_LIBRARIES)
endif(WITH_MP4V2)

### Check for id3lib
set(ID3LIB_LIBRARIES)
set(ID3LIB_DEFINITIONS)
if(WITH_ID3LIB)
  find_path(ID3LIB_INCLUDE_DIR id3/tag.h)
  find_library(ID3LIB_LIBRARIES NAMES id3)
  if(ID3LIB_INCLUDE_DIR AND ID3LIB_LIBRARIES)
    message(STATUS "id3lib found: ${ID3LIB_LIBRARIES}")
    set(HAVE_ID3LIB 1)
    if (WIN32)
      find_library(_ZLIB_PATH_NAME z)
      if (_ZLIB_PATH_NAME)
        get_filename_component(_ZLIB_PATH ${_ZLIB_PATH_NAME} PATH)
      else (_ZLIB_PATH_NAME)
        message(FATAL_ERROR "Could not find zlib")
      endif (_ZLIB_PATH_NAME)
      set(ID3LIB_DEFINITIONS -DID3LIB_LINKOPTION=1)
      set(ID3LIB_LIBRARIES ${ID3LIB_LIBRARIES} "-L${_ZLIB_PATH}" -lz -lstdc++)
    elseif (APPLE)
      set(ID3LIB_LIBRARIES ${ID3LIB_LIBRARIES} -lz -liconv)
    endif (WIN32)
    set(_CMAKE_REQUIRED_LIBRARIES_TMP ${CMAKE_REQUIRED_LIBRARIES})
    set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${ID3LIB_LIBRARIES} -lz -lstdc++)
    set(_CMAKE_REQUIRED_INCLUDES_TMP ${CMAKE_REQUIRED_INCLUDES})
    set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${ID3LIB_INCLUDE_DIR})
    set(_CMAKE_REQUIRED_DEFINITIONS_TMP ${CMAKE_REQUIRED_DEFINITIONS})
    set(CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS} ${ID3LIB_DEFINITIONS})
    CHECK_CXX_SOURCE_COMPILES("#include <id3/globals.h>\nint main() {\n  Mp3_Headerinfo info;\n  info.vbr_bitrate = 0;\n  return 0;\n}\n" ID3LIB_VBR_SUPPORT_FOUND)
    set(CMAKE_REQUIRED_LIBRARIES ${_CMAKE_REQUIRED_LIBRARIES_TMP})
    set(CMAKE_REQUIRED_INCLUDES ${_CMAKE_REQUIRED_INCLUDES_TMP})
    set(CMAKE_REQUIRED_DEFINITIONS ${_CMAKE_REQUIRED_DEFINITIONS_TMP})

    if(NOT ID3LIB_VBR_SUPPORT_FOUND)
      set(HAVE_NO_ID3LIB_VBR 1)
    endif(NOT ID3LIB_VBR_SUPPORT_FOUND)
  else(ID3LIB_INCLUDE_DIR AND ID3LIB_LIBRARIES)
    message(FATAL_ERROR "Could not find id3lib")
  endif(ID3LIB_INCLUDE_DIR AND ID3LIB_LIBRARIES)
endif(WITH_ID3LIB)

### Check for TunePimp
set(TUNEPIMP_LIBRARIES)
set(HAVE_TUNEPIMP 0)
if(WITH_TUNEPIMP)
  find_path(TUNEPIMP_INCLUDE_DIR tunepimp/tp_c.h)
  if(NOT TUNEPIMP_INCLUDE_DIR)
    find_path(TUNEPIMP_INCLUDE_DIR tunepimp-0.5/tp_c.h)
  endif(NOT TUNEPIMP_INCLUDE_DIR)
  find_library(TUNEPIMP_LIBRARIES NAMES tunepimp)
  if(TUNEPIMP_INCLUDE_DIR AND TUNEPIMP_LIBRARIES)
    message(STATUS "TunePimp found: ${TUNEPIMP_LIBRARIES}")
    CHECK_LIBRARY_EXISTS(${TUNEPIMP_LIBRARIES} tp_SetFileNameEncoding "" TUNEPIMP_FOUND_VERSION_4)
    CHECK_LIBRARY_EXISTS(${TUNEPIMP_LIBRARIES} tr_GetPUID "" TUNEPIMP_FOUND_VERSION_5)
    if(TUNEPIMP_FOUND_VERSION_5)
      set(HAVE_TUNEPIMP 5)
    elseif(TUNEPIMP_FOUND_VERSION_4)
      set(HAVE_TUNEPIMP 4)
    else(TUNEPIMP_FOUND_VERSION_5)

=== src/CMakeLists.txt ===
if (WITH_GCC_PCH)
  if (WITH_KDE)
    set(_includeRegex "#include <[Qkcp]")
  else (WITH_KDE)
    set(_includeRegex "#include <[Qcp]")
  endif (WITH_KDE)
  if (CMAKE_BUILD_TYPE MATCHES Debug)
    set(_additionalFlags "-g -DQT_DEBUG -D_REENTRANT")
  else (CMAKE_BUILD_TYPE MATCHES Debug)
    set(_additionalFlags "-O3 -DQT_NO_DEBUG -D_REENTRANT -DNDEBUG")
  endif (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_CXX_FLAGS
    "${CMAKE_CXX_FLAGS} -Winvalid-pch -include ${CMAKE_BINARY_DIR}/allsys.h")

  macro (ADD_KID3_PCH_RULE _srcList)
    ADD_PCH_HEADERFILE_RULE(${CMAKE_BINARY_DIR}/allsys.h
                            ${CMAKE_CURRENT_SOURCE_DIR} ${_includeRegex})
    ADD_PCH_RULE(${CMAKE_BINARY_DIR}/allsys.h ${_srcList} ${_additionalFlags})
  endmacro (ADD_KID3_PCH_RULE _srcList)
endif (WITH_GCC_PCH)

add_subdirectory(core)
add_subdirectory(gui)

=== src/core/CMakeLists.txt ===
include_directories(utils config tags formats export import model)

set(core_SRCS)
set(core_MOC_HDRS)
foreach (_subdir utils config tags formats export import model)
  include(${_subdir}/Sources.cmake)
  set(core_SRCS ${core_SRCS} ${${_subdir}_SRCS})
  set(core_MOC_HDRS ${core_MOC_HDRS} ${${_subdir}_MOC_HDRS})
endforeach()

if (WITH_GCC_PCH)
  ADD_KID3_PCH_RULE(core_SRCS)
endif (WITH_GCC_PCH)

qt4_wrap_cpp(core_GEN_MOC_SRCS ${core_MOC_HDRS})

add_library(kid3-core ${core_SRCS} ${core_GEN_MOC_SRCS})
target_link_libraries(kid3-core
  ${BASIC_LIBRARIES} ${ID3LIB_LIBRARIES} ${TAGLIB_LIBRARIES} ${VORBIS_LIBRARIES}
  ${FLAC_LIBRARIES} ${TUNEPIMP_LIBRARIES} ${MP4V2_LIBRARIES}
)

if (BUILD_SHARED_LIBS)
  install(TARGETS kid3-core
    LIBRARY DESTINATION ${WITH_LIBDIR}
    ARCHIVE DESTINATION ${WITH_LIBDIR}
    RUNTIME DESTINATION ${WITH_BINDIR})
endif (BUILD_SHARED_LIBS)

if (WITH_KDE)
  install(FILES model/net.sourceforge.Kid3.xml
          DESTINATION ${DBUS_INTERFACES_INSTALL_DIR})
endif (WITH_KDE)

=== src/gui/CMakeLists.txt ===
include_directories(
  ../core/utils ../core/config ../core/tags ../core/export ../core/import ../core/model
  widgets dialogs
)

set(gui_SRCS)
set(gui_MOC_HDRS)
foreach (_subdir widgets dialogs forms)
  include(${_subdir}/Sources.cmake)
  set(gui_SRCS ${gui_SRCS} ${${_subdir}_SRCS})
  set(gui_MOC_HDRS ${gui_MOC_HDRS} ${${_subdir}_MOC_HDRS})
endforeach()

if (WITH_GCC_PCH)
  ADD_KID3_PCH_RULE(gui_SRCS)
endif (WITH_GCC_PCH)

qt4_wrap_cpp(gui_GEN_MOC_SRCS ${gui_MOC_HDRS})

add_library(kid3-gui ${gui_SRCS} ${gui_GEN_MOC_SRCS})
target_link_libraries(kid3-gui kid3-core)

if (BUILD_SHARED_LIBS)
  install(TARGETS kid3-gui
    LIBRARY DESTINATION ${WITH_LIBDIR}
    ARCHIVE DESTINATION ${WITH_LIBDIR}
    RUNTIME DESTINATION ${WITH_BINDIR})
endif (BUILD_SHARED_LIBS)

include_directories(forms)
add_subdirectory(app)

=== src/gui/app/CMakeLists.txt ===
set(kid3_SRCS main.cpp)

if (WITH_KDE)

  kde4_add_executable(kid3 ${kid3_SRCS})

  target_link_libraries(kid3 kid3-gui)

  install(TARGETS kid3 DESTINATION ${BIN_INSTALL_DIR})
  install(FILES kid3.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
  install(FILES kid3ui.rc DESTINATION ${DATA_INSTALL_DIR}/kid3)

  kde4_install_icons(${ICON_INSTALL_DIR})

else (WITH_KDE)

  if (APPLE)
    # Icon and properties for .plist file
    set(MACOSX_BUNDLE_ICON_FILE kid3.icns)
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
    set(MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.kid3")
    set(MACOSX_BUNDLE_COPYRIGHT "Copyright (c) 2003-${RELEASE_YEAR} Urs Fleisch")
    set_source_files_properties(kid3.icns
      PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
    set(kid3_SRCS ${kid3_SRCS} kid3.icns)
  elseif (WIN32)
    if (MINGW)
      # support for Windows resource files with MinGW
      set(CMAKE_RC_COMPILER_INIT windres)
      enable_language(RC)
      set(CMAKE_RC_COMPILE_OBJECT
        "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
    endif (MINGW)
    # add Windows resource file with icon
    set(kid3_SRCS ${kid3_SRCS} kid3win.rc)
  endif (APPLE)

  if (UNIX AND NOT APPLE)
    # install desktop file and icons for Linux
    add_custom_command(OUTPUT kid3-qt.desktop
      COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixdesktop.pl
        <${CMAKE_CURRENT_SOURCE_DIR}/kid3.desktop >kid3-qt.desktop
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/kid3.desktop
    )
    add_custom_target("desktop-file" ALL DEPENDS kid3-qt.desktop)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.desktop
      DESTINATION "${WITH_DATAROOTDIR}/applications")
    install(FILES hisc-app-kid3.svgz
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps"
            RENAME kid3-qt.svgz)
    install(FILES hi48-app-kid3.png
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/48x48/apps"
            RENAME kid3-qt.png)
    install(FILES hi32-app-kid3.png
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/32x32/apps"
            RENAME kid3-qt.png)
    install(FILES hi16-app-kid3.png
            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/16x16/apps"
            RENAME kid3-qt.png)
  endif (UNIX AND NOT APPLE)

  add_definitions(${QT_DEFINITIONS})
  set(kid3_RESOURCES kid3.qrc)
  qt4_add_resources(kid3_GEN_RCS ${kid3_RESOURCES})
  add_executable(${KID3_EXECUTABLE} MACOSX_BUNDLE WIN32
    ${kid3_SRCS} ${kid3_GEN_RCS})

  target_link_libraries(${KID3_EXECUTABLE} kid3-gui)

  install(TARGETS ${KID3_EXECUTABLE}
    BUNDLE DESTINATION .
    RUNTIME DESTINATION ${WITH_BINDIR})

  if (APPLE OR WIN32)

    # Put Qt libraries and plugins into installation package to create a
    # standalone bundle on Mac OS X and Windows
    set(plugin_dest_dir ${WITH_BINDIR})
    set(bundle_app
     "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/${KID3_EXECUTABLE}")
    if (APPLE)
      set(plugin_dest_dir kid3.app/Contents/PlugIns)
      set(bundle_app "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app")
    endif (APPLE)
    if (WIN32)
      set(bundle_app
        "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${WITH_BINDIR}/kid3.exe")
    endif (WIN32)
    string(REPLACE "/./" "/" bundle_app ${bundle_app})

    # Install Qt JPEG and Phonon plugins
    install(DIRECTORY "${QT_PLUGINS_DIR}/imageformats"
      DESTINATION ${plugin_dest_dir}
      FILES_MATCHING PATTERN "*jpeg${CMAKE_SHARED_LIBRARY_SUFFIX}"
                     PATTERN "*jpeg4${CMAKE_SHARED_LIBRARY_SUFFIX}")

    if (HAVE_PHONON)
      install(DIRECTORY "${QT_PLUGINS_DIR}/phonon_backend"
        DESTINATION ${plugin_dest_dir}
        FILES_MATCHING
          PATTERN "*d4${CMAKE_SHARED_LIBRARY_SUFFIX}" EXCLUDE
          PATTERN "*${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif (HAVE_PHONON)

    # Install and fix up all dependencies of the executable and the plugins.
    # On Mac OS X only keep the i386 code in the Qt libraries and plugins.
    install(CODE "
      file(GLOB_RECURSE QTPLUGINS
        \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${plugin_dest_dir}/*${CMAKE_SHARED_LIBRARY_SUFFIX}\")
      include(BundleUtilities)
      fixup_bundle(\"${bundle_app}\" \"\${QTPLUGINS}\" \"${QT_LIBRARY_DIR}\")
      if (APPLE)
        file(GLOB_RECURSE _qtlibs \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app/Contents/Frameworks/*Qt*\")
        file(GLOB_RECURSE _plugins \"\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/kid3.app/Contents/PlugIns/*.dylib\")
        foreach (_universalBinary \${_plugins} \${_qtlibs})
          execute_process(COMMAND lipo \${_universalBinary} -output \${_universalBinary} -thin i386)
        endforeach (_universalBinary \${plugins})
      endif (APPLE)
      ")

  endif (APPLE OR WIN32)

endif (WITH_KDE)

=== debian/changelog ===
kid3 (2.0.1-2) unstable; urgency=low

  * Do not build the package with libtunepimp.
    Closes: #657018
  * Add missing build-arch and build-indep debian/rules target.
  * Add doc-base registration for the kid3-qt package.
  * Repair broken common symlinks in the kid3 package and add an lintian
    overwrite for it (false positive).
    Closes: #583333

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 25 Jan 2012 16:07:08 +0100

kid3 (2.0.1-1) unstable; urgency=low

  * New upstream release.

  [ Patrick Matthäi ]
  * Adjust build system.
  * Add build dependency xsltproc.

  [ Ana Beatriz Guerrero Lopez ]
  * Some more adjustments to the build system taken from upstream's deb/
  * directory.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Sun, 13 Nov 2011 16:34:13 +0100

=== debian/control ===
Source: kid3
Section: kde
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Ana Beatriz Guerrero Lopez <ana@debian.org>,
 Mark Purcell <msp@debian.org>,
 Patrick Matthäi <pmatthaei@debian.org>
Build-Depends: debhelper (>= 7),
 libqt4-dev,
 kdelibs5-dev,
 cmake,
 libid3-3.8.3-dev (>= 3.8.3-4.2),
 libflac++-dev (>= 1.1.2),
 libvorbis-dev,
 libtag1-dev,
 hardening-wrapper,
 docbook-utils,
 xsltproc
Standards-Version: 3.9.2
Homepage: http://kid3.sourceforge.net/
Vcs-Svn: svn://svn.debian.org/pkg-kde/kde-extras/kid3/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/pkg-kde/kde-extras/kid3/?op=log

Package: kid3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: KDE MP3 ID3 tag editor
 With Kid3, an ID3 tag editor for KDE you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit Ogg/Vorbis tags
  * Edit FLAC tags
  * Edit APE tags in MPC files
  * Edit tags in MP3, Ogg/Vorbis, FLAC, MPC, MP4/AAC, MP2, Speex,
    TrueAudio and WavPack files
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs
 .
 This package uses KDE libraries, if you do not use KDE you should use kid3-qt.

Package: kid3-qt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Audio tag editor
 With Kid3, an audio tag editor you can:
  * Edit ID3v1.1 tags in your MP3 files
  * Edit all ID3v2.3 and ID3v2.4 frames in your MP3 files
  * Convert between ID3v1.1, ID3v2.3 and ID3v2.4 tags
  * Edit Ogg/Vorbis tags
  * Edit FLAC tags
  * Edit APE tags in MPC files
  * Edit tags in MP3, Ogg/Vorbis, FLAC, MPC, MP4/AAC, MP2, Speex,
    TrueAudio and WavPack files
  * Edit tags of multiple files, e.g. the artist, album, year and genre
    of all files of an album typically have the same values and can be
    set together
  * Generate tags from filenames
  * Generate filenames from tags
  * Generate playlist files
  * Automatic case conversion and string translation
  * Import and export album data
  * Import from gnudb.org, TrackType.org, MusicBrainz, Discogs
 .
 This package does not use KDE libraries, if you use KDE you should use kid3.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1

pixmaps = $(CURDIR)/debian/kid3/usr/share/pixmaps
bindir = $(CURDIR)/debian/kid3/usr/bin
kdedocs = $(CURDIR)/debian/kid3/usr/share/doc/kde/HTML

DEBVERSION:=$(shell head -n 1 debian/changelog \
                    | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
UPVERSION:=$(shell echo $(DEBVERSION) | sed -e 's/^.*://' -e 's/-[0-9.]*$$//' -e 's/.dfsg$$//')

FILENAME := kid3_$(UPVERSION).orig.tar.gz
UPFILENAME := kid3-$(UPVERSION).tar.gz
URL = http://heanet.dl.sourceforge.net/kid3/$(UPFILENAME)

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

build: build-stamp

build-arch: build

build-indep: build

DEB_CMAKE_PREFIX = /usr
DEB_CONFIG_INSTALL_DIR = $(DEB_CMAKE_PREFIX)/share/kde4/config
DEB_HTML_INSTALL_DIR = $(DEB_CMAKE_PREFIX)/share/doc/kde/HTML

CMAKE_KDE4_FLAGS += \
	-DCMAKE_SKIP_RPATH=true \
	-DKDE4_USE_ALWAYS_FULL_RPATH=false \
	-DWITH_MP4V2=false \
	-DWITH_TUNEPIMP=false \
	-DSYSCONF_INSTALL_DIR=/etc \
	-DCMAKE_INSTALL_PREFIX=$(DEB_CMAKE_PREFIX) \
	-DCONFIG_INSTALL_DIR=$(DEB_CONFIG_INSTALL_DIR) \
	-DDATA_INSTALL_DIR=$(DEB_CMAKE_PREFIX)/share/kde4/apps \
	-DHTML_INSTALL_DIR=$(DEB_HTML_INSTALL_DIR) \
	-DKCFG_INSTALL_DIR=$(DEB_CMAKE_PREFIX)/share/kde4/config.kcfg \
	-DLIB_INSTALL_DIR=$(DEB_CMAKE_PREFIX)/lib

CMAKE_QT4_FLAGS = \
	-DCMAKE_SKIP_RPATH=ON \
	-DCMAKE_INSTALL_PREFIX="$(DEB_CMAKE_PREFIX)" \
	-DCMAKE_C_COMPILER:FILEPATH="$(CC)" \
	-DCMAKE_CXX_COMPILER:FILEPATH="$(CXX)" \
	-DCMAKE_C_FLAGS="$(CFLAGS)" \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DWITH_MP4V2=OFF \
	-DWITH_TUNEPIMP=OFF \
	-DWITH_KDE=OFF \
	-DWITH_DATAROOTDIR=share \
	-DWITH_DOCDIR=share/doc/kid3-qt \
	-DWITH_TRANSLATIONSDIR=share/kid3-qt/translations \
	-DWITH_BINDIR=bin

build-stamp:
	dh_testdir
	# KDE4 build.
	mkdir kid3-kde4
	cd kid3-kde4 && cmake .. $(CMAKE_KDE4_FLAGS)
	$(MAKE) -C kid3-kde4
	# Qt4 build.
	mkdir kid3-qt
	cd kid3-qt && cmake .. -DWITH_KDE=OFF $(CMAKE_QT4_FLAGS)
	$(MAKE) -C kid3-qt
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	[ ! -f kid3-qt/Makefile ] || $(MAKE) -C kid3-qt clean
	[ ! -f kid3-kde4/Makefile ] || $(MAKE) -C kid3-kde4 clean
	rm -rf kid3-kde4 kid3-qt
	rm -f *-stamp po/*.gmo
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	# Main install.
	$(MAKE) -C kid3-kde4 install DESTDIR=$(CURDIR)/debian/kid3
	$(MAKE) -C kid3-qt install DESTDIR=$(CURDIR)/debian/kid3-qt
	rm $(CURDIR)/debian/kid3/usr/share/doc/kde/HTML/*/kid3/common

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs -A AUTHORS NEWS README
	dh_installmenu
	dh_installman
	dh_installchangelogs ChangeLog
	dh_icons
	dh_link
	dh_lintian
	dh_strip
	dh_compress --exclude=.docbook
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

get-orig-source:
	@@dh_testdir
	@@[ -d ../tarballs/. ]||mkdir -p ../tarballs
	@@echo Downloading $(UPFILENAME) from $(URL) ...
	@@wget -N -nv -T10 -t3 -O ../tarballs/$(FILENAME) $(URL)

## kid3 2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,12 +9,12 @@
 # Windows:
 # set INCLUDE=%MSYSDIR%\local\include
 # set LIB=%MSYSDIR%\local\lib
-# cmake -G "MinGW Makefiles" -D CMAKE_BUILD_TYPE=Release -D CMAKE_INSTALL_PREFIX= -D WITH_TUNEPIMP=OFF ..\kid3
+# cmake -G "MinGW Makefiles" -D CMAKE_BUILD_TYPE=Release -D CMAKE_INSTALL_PREFIX= -D WITH_CHROMAPRINT=OFF ..\kid3
 # mingw32-make
 # cpack
 #
 # Mac OS X:
-# cmake -G "Unix Makefiles" -D CMAKE_BUILD_TYPE=Release -D CMAKE_INSTALL_PREFIX= -D WITH_TUNEPIMP=OFF ../kid3
+# cmake -G "Unix Makefiles" -D CMAKE_BUILD_TYPE=Release -D CMAKE_INSTALL_PREFIX= -D WITH_CHROMAPRINT=OFF ../kid3
 # make
 # cpack
 
@@ -25,7 +25,7 @@
 set(WITH_ID3LIB ON CACHE BOOL "build with id3lib")
 set(WITH_VORBIS ON CACHE BOOL "build with Ogg/Vorbis")
 set(WITH_FLAC ON CACHE BOOL "build with FLAC")
-set(WITH_TUNEPIMP ON CACHE BOOL "build with TunePimp")
+set(WITH_CHROMAPRINT ON CACHE BOOL "build with Chromaprint")
 set(WITH_DBUS ON CACHE BOOL "build with QtDBus")
 set(WITH_PHONON ON CACHE BOOL "build with Phonon")
 set(WITH_GCC_PCH OFF CACHE BOOL "enable precompiled headers")
@@ -37,9 +37,11 @@
 
 # Version information
 set(CPACK_PACKAGE_VERSION_MAJOR 2)
-set(CPACK_PACKAGE_VERSION_MINOR 0)
-set(CPACK_PACKAGE_VERSION_PATCH 1)
-set(RELEASE_YEAR 2011)
+set(CPACK_PACKAGE_VERSION_MINOR 1)
+set(CPACK_PACKAGE_VERSION_PATCH 0)
+set(CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
+#set(CPACK_PACKAGE_VERSION "git20120422")
+set(RELEASE_YEAR 2012)
 
 if (WITH_GCC_PCH)
 include(GccPchMacros.cmake)
@@ -56,10 +58,6 @@
 # Set variables used to install shared libraries
 set(WITH_BINDIR ${BIN_INSTALL_DIR})
 set(WITH_LIBDIR ${LIB_INSTALL_DIR})
-
-if (BUILD_SHARED_LIBS AND __KDE_HAVE_GCC_VISIBILITY)
-  message(WARNING "Use -D__KDE_HAVE_GCC_VISIBILITY=OFF to build KDE shared libraries")
-endif (BUILD_SHARED_LIBS AND __KDE_HAVE_GCC_VISIBILITY)
 
 else (WITH_KDE)
 
@@ -107,13 +105,48 @@
 set(CFG_TRANSLATIONSDIR ${CMAKE_INSTALL_PREFIX_SLASH}${WITH_TRANSLATIONSDIR})
 
 cmake_minimum_required(VERSION 2.8)
-set(_QT4_COMPONENTS QtCore QtGui QtNetwork QtXml)
-if (WIN32)
-  set(QT_USE_QTMAIN TRUE)
-endif (WIN32)
-set(QT_USE_QTDBUS ${WITH_DBUS})
-find_package(Qt4 COMPONENTS ${_QT4_COMPONENTS} REQUIRED)
-include (${QT_USE_FILE})
+string(REGEX MATCH "^.*qt5" _qt5Dir "${QT_QMAKE_EXECUTABLE}")
+if (_qt5Dir)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
+  set(Qt5Core_DIR "${_qt5Dir}/lib/cmake/Qt5Core")
+  set(Qt5Gui_DIR "${_qt5Dir}/lib/cmake/Qt5Gui")
+  set(Qt5Widgets_DIR "${_qt5Dir}/lib/cmake/Qt5Widgets")
+  set(Qt5Network_DIR "${_qt5Dir}/lib/cmake/Qt5Network")
+  set(Qt5Xml_DIR "${_qt5Dir}/lib/cmake/Qt5Xml")
+  set(Qt5LinguistTools_DIR "${_qt5Dir}/lib/cmake/Qt5LinguistTools")
+  set(QT_INCLUDES)
+  set(QT_DEFINITIONS)
+  set(QT_LIBRARIES)
+  foreach (_qt5Component Core Gui Widgets Network Xml LinguistTools)
+    find_package("Qt5${_qt5Component}")
+    set(QT_INCLUDES ${QT_INCLUDES} ${Qt5${_qt5Component}_INCLUDE_DIRS})
+    set(QT_DEFINITIONS ${QT_DEFINITIONS} ${Qt5${_qt5Component}_DEFINITIONS})
+    set(QT_LIBRARIES ${QT_LIBRARIES} ${Qt5${_qt5Component}_LIBRARIES})
+  endforeach ()
+  set(QT_LIBRARY_DIR "${_qt5Dir}/lib")
+  set(QT_INCLUDE_DIR "${_qt5Dir}/include")
+
+  macro(qt4_add_translation)
+    qt5_add_translation(${ARGV})
+  endmacro(qt4_add_translation)
+
+  macro(qt4_wrap_cpp)
+    qt5_wrap_cpp(${ARGV})
+  endmacro(qt4_wrap_cpp)
+
+  macro(qt4_add_resources)
+    qt5_add_resources(${ARGV})
+  endmacro(qt4_add_resources)
+else (_qt5Dir)
+  set(_QT4_COMPONENTS QtCore QtGui QtNetwork QtXml)
+  if (WIN32)
+    set(QT_USE_QTMAIN TRUE)
+  endif (WIN32)
+  set(QT_USE_QTDBUS ${WITH_DBUS})
+  find_package(Qt4 COMPONENTS ${_QT4_COMPONENTS} REQUIRED)
+  include (${QT_USE_FILE})
+endif (_qt5Dir)
 include (CheckCXXSourceCompiles)
 find_package(Perl REQUIRED)
 
@@ -162,6 +195,10 @@
 if (WIN32)
 link_directories($ENV{LIB})
 endif (WIN32)
+
+if (BUILD_SHARED_LIBS)
+  add_definitions(-DKID3_SHARED)
+endif (BUILD_SHARED_LIBS)
 
 ### Check for taglib
 set(TAGLIB_LIBRARIES)
@@ -275,34 +312,3 @@
     set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${ID3LIB_INCLUDE_DIR})
     set(_CMAKE_REQUIRED_DEFINITIONS_TMP ${CMAKE_REQUIRED_DEFINITIONS})
     set(CMAKE_REQUIRED_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS} ${ID3LIB_DEFINITIONS})
-    CHECK_CXX_SOURCE_COMPILES("#include <id3/globals.h>\nint main() {\n  Mp3_Headerinfo info;\n  info.vbr_bitrate = 0;\n  return 0;\n}\n" ID3LIB_VBR_SUPPORT_FOUND)
-    set(CMAKE_REQUIRED_LIBRARIES ${_CMAKE_REQUIRED_LIBRARIES_TMP})
-    set(CMAKE_REQUIRED_INCLUDES ${_CMAKE_REQUIRED_INCLUDES_TMP})
-    set(CMAKE_REQUIRED_DEFINITIONS ${_CMAKE_REQUIRED_DEFINITIONS_TMP})
-
-    if(NOT ID3LIB_VBR_SUPPORT_FOUND)
-      set(HAVE_NO_ID3LIB_VBR 1)
-    endif(NOT ID3LIB_VBR_SUPPORT_FOUND)
-  else(ID3LIB_INCLUDE_DIR AND ID3LIB_LIBRARIES)
-    message(FATAL_ERROR "Could not find id3lib")
-  endif(ID3LIB_INCLUDE_DIR AND ID3LIB_LIBRARIES)
-endif(WITH_ID3LIB)
-
-### Check for TunePimp
-set(TUNEPIMP_LIBRARIES)
-set(HAVE_TUNEPIMP 0)
-if(WITH_TUNEPIMP)
-  find_path(TUNEPIMP_INCLUDE_DIR tunepimp/tp_c.h)
-  if(NOT TUNEPIMP_INCLUDE_DIR)
-    find_path(TUNEPIMP_INCLUDE_DIR tunepimp-0.5/tp_c.h)
-  endif(NOT TUNEPIMP_INCLUDE_DIR)
-  find_library(TUNEPIMP_LIBRARIES NAMES tunepimp)
-  if(TUNEPIMP_INCLUDE_DIR AND TUNEPIMP_LIBRARIES)
-    message(STATUS "TunePimp found: ${TUNEPIMP_LIBRARIES}")
-    CHECK_LIBRARY_EXISTS(${TUNEPIMP_LIBRARIES} tp_SetFileNameEncoding "" TUNEPIMP_FOUND_VERSION_4)
-    CHECK_LIBRARY_EXISTS(${TUNEPIMP_LIBRARIES} tr_GetPUID "" TUNEPIMP_FOUND_VERSION_5)
-    if(TUNEPIMP_FOUND_VERSION_5)
-      set(HAVE_TUNEPIMP 5)
-    elseif(TUNEPIMP_FOUND_VERSION_4)
-      set(HAVE_TUNEPIMP 4)
-    else(TUNEPIMP_FOUND_VERSION_5)

=== doc/CMakeLists.txt ===
if (NOT WITH_KDE)

# Create HTML handbook from DocBook file in language directory
macro (kid3_create_handbook _docbook)
  get_filename_component(_input ${_docbook} ABSOLUTE)
  get_filename_component(_lang ${CMAKE_CURRENT_SOURCE_DIR} NAME)
  set(_output ${CMAKE_CURRENT_BINARY_DIR}/kid3_${_lang}.html)
  set(_fixdocbook_pl ${CMAKE_CURRENT_SOURCE_DIR}/../fixdocbook.pl)
  set(_fixhtml_pl ${CMAKE_CURRENT_SOURCE_DIR}/../fixhtml.pl)
  set(_docbook_xsl ${DOCBOOK_XSL_DIR}/html/docbook.xsl)
  if (WIN32)
    # The expressions in pipes do not work for Windows,
    # so temporary files are used.
    set(_tmp_xml ${CMAKE_CURRENT_BINARY_DIR}/tmp.xml)
    set(_tmp_html ${CMAKE_CURRENT_BINARY_DIR}/tmp.html)
    add_custom_command(OUTPUT ${_tmp_xml}
      COMMAND ${PERL_EXECUTABLE} ${_fixdocbook_pl} <${_input} >${_tmp_xml}
      DEPENDS ${_input}
    )
    add_custom_command(OUTPUT ${_tmp_html}
      COMMAND ${XSLTPROC} --novalid --nonet ${_docbook_xsl} ${_tmp_xml} >${_tmp_html}
      DEPENDS ${_tmp_xml}
    )
    add_custom_command(OUTPUT ${_output}
      COMMAND ${PERL_EXECUTABLE} -n ${_fixhtml_pl} <${_tmp_html} >${_output}
      DEPENDS ${_tmp_html}
    )
  else (WIN32)
    add_custom_command(OUTPUT ${_output}
      COMMAND
        ${PERL_EXECUTABLE} ${_fixdocbook_pl} <${_input} |
        ${XSLTPROC} --novalid --nonet ${_docbook_xsl} - |
        ${PERL_EXECUTABLE} -n ${_fixhtml_pl} >${_output}
      DEPENDS ${_input}
    )
  endif (WIN32)
  add_custom_target("${_lang}-handbook" ALL DEPENDS ${_output})
  install(FILES ${_output} DESTINATION ${WITH_DOCDIR})
endmacro (kid3_create_handbook)

endif (NOT WITH_KDE)

add_subdirectory(en)
add_subdirectory(de)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,10 +4,11 @@
   else (WITH_KDE)
     set(_includeRegex "#include <[Qcp]")
   endif (WITH_KDE)
+  set(_additionalFlags "-fno-exceptions -D_REENTRANT -DQT_NO_EXCEPTIONS -DQT_NO_STL -fvisibility=hidden -fvisibility-inlines-hidden")
   if (CMAKE_BUILD_TYPE MATCHES Debug)
-    set(_additionalFlags "-g -DQT_DEBUG -D_REENTRANT")
+    set(_additionalFlags "${_additionalFlags} -g -DQT_DEBUG")
   else (CMAKE_BUILD_TYPE MATCHES Debug)
-    set(_additionalFlags "-O3 -DQT_NO_DEBUG -D_REENTRANT -DNDEBUG")
+    set(_additionalFlags "${_additionalFlags} -O3 -DQT_NO_DEBUG -DNDEBUG")
   endif (CMAKE_BUILD_TYPE MATCHES Debug)
   set(CMAKE_CXX_FLAGS
     "${CMAKE_CXX_FLAGS} -Winvalid-pch -include ${CMAKE_BINARY_DIR}/allsys.h")

=== doc/de/CMakeLists.txt ===
if (WITH_KDE)

kde4_create_handbook(index.docbook INSTALL_DESTINATION ${HTML_INSTALL_DIR}/de SUBDIR kid3)

else (WITH_KDE)

kid3_create_handbook(index.docbook)

endif (WITH_KDE)

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,11 @@
   set(core_MOC_HDRS ${core_MOC_HDRS} ${${_subdir}_MOC_HDRS})
 endforeach()
 
+add_definitions(-DKID3_BUILD_CORE_LIB)
+if (WIN32 AND HAVE_CHROMAPRINT)
+  add_definitions(-DCHROMAPRINT_NODLL)
+endif (WIN32 AND HAVE_CHROMAPRINT)
+
 if (WITH_GCC_PCH)
   ADD_KID3_PCH_RULE(core_SRCS)
 endif (WITH_GCC_PCH)
@@ -17,7 +22,7 @@
 add_library(kid3-core ${core_SRCS} ${core_GEN_MOC_SRCS})
 target_link_libraries(kid3-core
   ${BASIC_LIBRARIES} ${ID3LIB_LIBRARIES} ${TAGLIB_LIBRARIES} ${VORBIS_LIBRARIES}
-  ${FLAC_LIBRARIES} ${TUNEPIMP_LIBRARIES} ${MP4V2_LIBRARIES}
+  ${FLAC_LIBRARIES} ${CHROMAPRINT_LIBS} ${MP4V2_LIBRARIES}
 )
 
 if (BUILD_SHARED_LIBS)

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,8 @@
   set(gui_SRCS ${gui_SRCS} ${${_subdir}_SRCS})
   set(gui_MOC_HDRS ${gui_MOC_HDRS} ${${_subdir}_MOC_HDRS})
 endforeach()
+
+add_definitions(-DKID3_BUILD_GUI_LIB)
 
 if (WITH_GCC_PCH)
   ADD_KID3_PCH_RULE(gui_SRCS)

=== src/gui/app/CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
   if (APPLE)
     # Icon and properties for .plist file
     set(MACOSX_BUNDLE_ICON_FILE kid3.icns)
-    set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
+    set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${CPACK_PACKAGE_VERSION})
     set(MACOSX_BUNDLE_GUI_IDENTIFIER "net.sourceforge.kid3")
     set(MACOSX_BUNDLE_COPYRIGHT "Copyright (c) 2003-${RELEASE_YEAR} Urs Fleisch")
     set_source_files_properties(kid3.icns
@@ -36,6 +36,7 @@
   endif (APPLE)
 
   if (UNIX AND NOT APPLE)
+    find_program(GZIP_PROGRAM gzip)
     # install desktop file and icons for Linux
     add_custom_command(OUTPUT kid3-qt.desktop
       COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/fixdesktop.pl
@@ -45,9 +46,19 @@
     add_custom_target("desktop-file" ALL DEPENDS kid3-qt.desktop)
     install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.desktop
       DESTINATION "${WITH_DATAROOTDIR}/applications")
-    install(FILES hisc-app-kid3.svgz
-            DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps"
-            RENAME kid3-qt.svgz)
+    if (GZIP_PROGRAM)
+      add_custom_command(OUTPUT kid3-qt.svg
+        COMMAND ${GZIP_PROGRAM} -cd ${CMAKE_CURRENT_SOURCE_DIR}/hisc-app-kid3.svgz >kid3-qt.svg
+        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/hisc-app-kid3.svgz
+      )
+      set(kid3_SRCS ${kid3_SRCS} ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg)
+      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kid3-qt.svg
+              DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps")
+    else (GZIP_PROGRAM)
+      install(FILES hisc-app-kid3.svgz
+              DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/scalable/apps"
+              RENAME kid3-qt.svgz)
+    endif (GZIP_PROGRAM)
     install(FILES hi48-app-kid3.png
             DESTINATION "${WITH_DATAROOTDIR}/icons/hicolor/48x48/apps"
             RENAME kid3-qt.png)
@@ -120,4 +131,15 @@
 
   endif (APPLE OR WIN32)
 
+  if (WIN32)
+    # Unfortunately, the binutils which come with the gcc-4.4.0 in the MinGW
+    # for Qt generate an executable which cannot be analyzed with dumpbin.
+    # This happens when Kid3 is linked with libav (used with Chromaprint).
+    # Therefore, the dependencies for kid3.exe are not added to the bundle.
+    # This workaround adds the missing files.
+    install(FILES "${QT_BINARY_DIR}/QtNetwork4.dll"
+                  "${QT_BINARY_DIR}/QtXml4.dll"
+            DESTINATION ${WITH_BINDIR})
+  endif (WIN32)
+
 endif (WITH_KDE)

=== debian/changelog ===
kid3 (2.1-2) unstable; urgency=low

  * Remove patch 01-gcc4.7-ftbfs, it was merged with 2.1 to another location.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 14 May 2012 18:27:44 +0200

kid3 (2.1-1) unstable; urgency=low

  * New upstream release.
    - Add new build dependencies libchromaprint-dev, libavformat-dev,
      libavcodec-dev and pkg-config.

 -- Patrick Matthäi <pmatthaei@debian.org>  Sun, 13 May 2012 18:09:20 +0200

kid3 (2.0.1-4) unstable; urgency=low

  * Add patch 01-gcc4.7-ftbfs to fix a FTBFS with GCC 4.7.
    Closes: #667227

 -- Patrick Matthäi <pmatthaei@debian.org>  Wed, 04 Apr 2012 16:32:21 +0200

kid3 (2.0.1-3) unstable; urgency=low

  * Bump Standards-Version to 3.9.3 (no changed needed).
  * Wrap all debian/control fields.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 24 Feb 2012 19:22:47 +0100

=== debian/control ===
--- 
+++ 
@@ -13,17 +13,22 @@
  libflac++-dev (>= 1.1.2),
  libvorbis-dev,
  libtag1-dev,
+ libchromaprint-dev,
+ libavformat-dev,
+ libavcodec-dev,
  hardening-wrapper,
  docbook-utils,
+ pkg-config,
  xsltproc
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://kid3.sourceforge.net/
 Vcs-Svn: svn://svn.debian.org/pkg-kde/kde-extras/kid3/trunk/
 Vcs-Browser: http://svn.debian.org/wsvn/pkg-kde/kde-extras/kid3/?op=log
 
 Package: kid3
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends},
+ ${misc:Depends}
 Description: KDE MP3 ID3 tag editor
  With Kid3, an ID3 tag editor for KDE you can:
   * Edit ID3v1.1 tags in your MP3 files
@@ -48,7 +53,8 @@
 
 Package: kid3-qt
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends},
+ ${misc:Depends}
 Description: Audio tag editor
  With Kid3, an audio tag editor you can:
   * Edit ID3v1.1 tags in your MP3 files
